#include <sys/socket.h>
#include <netinet/in.h>
#include <arpa/inet.h>
#include <stdlib.h>
#include <unistd.h>
#include <stdio.h>
#include <string.h>

#define NOFLAGS 0
#define BLOCK_LENGTH 16

extern int sockfd;

int Oracle_Connect() {
  struct sockaddr_in servaddr, cliaddr;
  int rc;

  sockfd = socket(AF_INET, SOCK_STREAM, 0);

  bzero(&servaddr, sizeof(servaddr));
  servaddr.sin_family = AF_INET;
  servaddr.sin_addr.s_addr=inet_addr("54.165.60.84");
  servaddr.sin_port=htons(6667);

  if(!connect(sockfd, (struct sockaddr *)&servaddr, sizeof(servaddr))) {
    printf("Connected to server successfully.\n");
    return 0;
  } else {
    perror("Failed to connect to oracle");
    return -1;
  }
}

int Oracle_Disconnect() {
  if(!close(sockfd)) {
    printf("Connection closed successfully.\n");
    return 0;
  } else {
    perror("[WARNING]: You haven't connected to the server yet");
    return -1;
  }
}

// Packet Structure: < block (8) >
// Fills recvblock with return value from server
int Oracle_Send(unsigned char* block, unsigned char* recvblock) {

  if(!send(sockfd, block, 8, NOFLAGS)) {
    perror("[WARNING]: You haven't connected to the server yet");
    return -1;
  }
  if(!recv(sockfd, recvblock, 8, NOFLAGS)) {
    perror("[ERROR]: Recv failed");
    return -1;
  }

  return 0;
}

